import axios from 'axios'

const JSONbig = require('json-bigint-string');

axios.defaults.headers.get['Content-Type']='application/x-www-form-urlencoded';
axios.defaults.headers.post['Content-Type']='application/json';


axios.interceptors.request.use(function(config) {
  //在发送请求之前做某事
  return config;
}, function(error) {
  return Promise.reject(error);
});

axios.defaults.transformResponse =  [function (data) {
  // Do whatever you want to transform the data
  return JSONbig.parse(data);
}]


axios.interceptors.response.use(function(response) {
  // Do something with response data
  if(response && process.server && response.config) { // 服务端打印日志
    console.log("=====================seperate line=====================")
    console.log("axios from server url:", response.config.url)
  }
  // 非接口类 请求，直接返回
  if(!response) response = ''
  if(!response || !response.data || !response.data.code) return response;
 
  let data = response.data.data || '';
  let code = response.data.code;

  if(code == 'OK' || code == 200) {
    if(process.server) { // 服务端打印日志
      console.log("response:", JSON.stringify(data))
    }
    return data;
  } else {
    console.log('axios加载失败:', response.data);
  }
  // return response;
}, function(error) {
  // Do something with response error
  return Promise.reject(error);
});

export default axios
